import Service from '@ember/service';
import * as qs from 'qs';
import type RouterService from '@ember/routing/router-service';
interface QueryParams {
    [key: string]: number | string | QueryParams | qs.ParsedQs[keyof qs.ParsedQs];
}
interface QueryParamsByPath {
    [key: string]: QueryParams;
}
export default class QueryParamsService extends Service {
    router: RouterService;
    current: QueryParams;
    byPath: QueryParamsByPath;
    constructor(...args: any[]);
    get pathParts(): string[];
    private setupProxies;
    private updateParams;
    /**
     * When we have stored query params for a route
     * throw them on the URL
     *
     */
    private updateURL;
    private setOnPath;
}
declare module '@ember/service' {
    interface Registry {
        'query-params': QueryParams;
    }
}
export {};
